{-# LANGUAGE DerivingVia #-}

module Lib
  ( runBothServers,
  )
where

import ClassyPrelude
import State.ConnectedClientsState (initConnectionsState)
import State.RoomsState (initRoomsState)
import Types.AppTypes
import WebServer (runWebServer)
import WebSocket.Server (runWebSocketServer)

runBothServers :: IO ()
runBothServers = do
  connectedClientsState <- initConnectionsState
  roomsState <- initRoomsState

  let env =
        Env
          { connectedClientsState = connectedClientsState,
            profile = Dev,
            roomsState = roomsState
          }

  _ <- concurrently (unApp runWebSocketServer env) (unApp runWebServer env)
  return ()
