{-# LANGUAGE DerivingVia #-}

module Types.AppTypes (Env (..), App (..), getConnectedClientState, AppProfile (Prod, Dev)) where

import ClassyPrelude
import State.ConnectedClientsState
import State.RoomsState
  ( HasRoomsState (getRoomsState),
    RoomsState,
  )

data AppProfile = Prod | Dev

data Env = Env
  { connectedClientsState :: ConnectedClientsState,
    roomsState :: RoomsState,
    profile :: AppProfile
  }

instance HasConnectedClientState Env where
  getConnectedClientState = connectedClientsState

instance HasRoomsState Env where
  getRoomsState = roomsState

newtype App env a = App {unApp :: env -> IO a}
  deriving
    ( Functor,
      Applicative,
      Monad,
      MonadReader env,
      MonadIO
    )
    via ReaderT env IO
